#include <stdio.h>
#include <stdint.h>
#include <math.h>

#include "libsat.h"

#define Q_N	16
#define Q_M	16
#define Q_SCALE	(1 << Q_N)

#define	SIZE	16384

int
main()
{
	FILE *p;
	int32_t x[SIZE], arg;
	int i;

	p = fopen("./data", "w");
	arg = sat_div(SAT_PI << 1, SIZE * Q_SCALE);
	for (i = 0; i < SIZE; i += 2) {
		x[i]	= sat_cos(sat_mul(arg, i * Q_SCALE));
		x[i+1]	= SAT_ZERO;
		fprintf(p, "%lf\n", x[i] / (double)Q_SCALE);
	}
	fclose(p);

	sat_fft(&x[0], SIZE/2, 0);

	
	for (i = 0; i < SIZE; i++)
		x[i] = sat_div(x[i], SIZE * Q_SCALE / 2);

	x[53] = 0.3 * Q_SCALE;
	x[10] = 0.35 * Q_SCALE;

	p = fopen("./data2", "w");
	for (i = 0; i < SIZE; i +=2)
		fprintf(p, "%lf\n", x[i] / (double)Q_SCALE);
	fclose(p);

	sat_fft(&x[0], SIZE/2, 1);

	p = fopen("./data3", "w");
	for (i = 0; i < SIZE; i += 2)
		fprintf(p, "%lf\n", x[i] / (double)Q_SCALE);
	fclose(p);

	return 0;
}
